diff --git a/source/src/cip/cipconnectionmanager.c b/source/src/cip/cipconnectionmanager.c
index 4ffd60d9a6..d51dfc3225 100644
--- a/source/src/cip/cipconnectionmanager.c
+++ b/source/src/cip/cipconnectionmanager.c
@@ -522,6 +522,19 @@ EipStatus ForwardOpen(
       kConnectionManagerExtendedStatusCodeErrorInvalidTToOConnectionType);
   }
 
+  if(kConnectionObjectConnectionTypeMulticast == t_to_o_connection_type) {
+    /* for multicast, check if IP is within configured net because we send TTL 1 */
+    CipUdint o_ip = ((struct sockaddr_in *)originator_address)->sin_addr.s_addr;
+    CipUdint i_ip = g_network_status.ip_address;
+    CipUdint i_mask = g_network_status.network_mask;
+    if((o_ip & i_mask)!=(i_ip & i_mask)) {
+      return AssembleForwardOpenResponse(
+        &g_dummy_connection_object, message_router_response,
+        kCipErrorConnectionFailure,
+        kConnectionManagerExtendedStatusCodeNotConfiguredForOffSubnetMulticast);
+    }
+  }
+
   /* Check if request is a Null request or a Non-Null request */
   if (kConnectionObjectConnectionTypeNull == o_to_t_connection_type
       && kConnectionObjectConnectionTypeNull == t_to_o_connection_type) {
diff --git a/source/src/enet_encap/encap.c b/source/src/enet_encap/encap.c
index 9edd6814f4..93061e36ef 100644
--- a/source/src/enet_encap/encap.c
+++ b/source/src/enet_encap/encap.c
@@ -445,7 +445,7 @@ void EncodeListIdentityCipIdentityItem(ENIPMessage *const outgoing_message) {
     &outgoing_message->current_message_position);
 
   outgoing_message->used_message_length += EncapsulateIpAddress(
-    htons(kOpenerEthernetPort), g_tcpip.interface_configuration.ip_address,
+    htons(kOpenerEthernetPort), g_network_status.ip_address,
     &outgoing_message->current_message_position);
 
   /** Array of USINT - length 8 shall be set to zero */
diff --git a/source/src/ports/generic_networkhandler.c b/source/src/ports/generic_networkhandler.c
index a2a089d751..015bb472d6 100644
--- a/source/src/ports/generic_networkhandler.c
+++ b/source/src/ports/generic_networkhandler.c
@@ -93,6 +93,10 @@ EipStatus NetworkHandlerInitialize(void) {
   CipQosUpdateUsedSetQosValues();
   /* Make sure the multicast configuration matches the current IP address. */
   CipTcpIpCalculateMulticastIp(&g_tcpip);
+  /* Freeze IP and network mask matching to the socket setup. This is needed
+   *  for the off subnet multicast routing check later. */
+  g_network_status.ip_address = g_tcpip.interface_configuration.ip_address;
+  g_network_status.network_mask = g_tcpip.interface_configuration.network_mask;
   /* Initialize encapsulation layer here because it accesses the IP address. */
   EncapsulationInit();
 
@@ -193,7 +197,7 @@ EipStatus NetworkHandlerInitialize(void) {
   struct sockaddr_in my_address = {
     .sin_family = AF_INET,
     .sin_port = htons(kOpenerEthernetPort),
-    .sin_addr.s_addr = g_tcpip.interface_configuration.ip_address
+    .sin_addr.s_addr = g_network_status.ip_address
   };
 
   /* bind the new socket to port 0xAF12 (CIP) */
@@ -632,9 +636,7 @@ EipStatus SendUdpData(struct sockaddr_in *address,
   UDPHeaderSetChecksum(&header,
                        htons(UDPHeaderCalculateChecksum(complete_message,
                                                         8 + data_length,
-                                                        g_tcpip.
-                                                        interface_configuration
-                                                        .ip_address,
+                                                        g_network_status.ip_address,
                                                         address->sin_addr.s_addr) ) );
   UDPHeaderGenerate(&header, (char *)complete_message);
 
@@ -972,7 +974,7 @@ int CreateUdpSocket(UdpCommuncationDirection communication_direction,
         /* Need to specify the interface for outgoing multicast packets on a device
             with multiple interfaces. */
         struct in_addr my_addr =
-        { .s_addr = g_tcpip.interface_configuration.ip_address };
+        { .s_addr = g_network_status.ip_address };
         if ( setsockopt(new_socket, IPPROTO_IP, IP_MULTICAST_IF,
                         NWBUF_CAST &my_addr.s_addr,
                         sizeof my_addr.s_addr ) < 0 ) {
diff --git a/source/src/ports/generic_networkhandler.h b/source/src/ports/generic_networkhandler.h
index a2c9d1ca0b..0b2034fb71 100644
--- a/source/src/ports/generic_networkhandler.h
+++ b/source/src/ports/generic_networkhandler.h
@@ -52,6 +52,8 @@ typedef struct {
   int tcp_listener; /**< TCP listener socket */
   int udp_unicast_listener; /**< UDP unicast listener socket */
   int udp_global_broadcast_listener; /**< UDP global network broadcast listener */
+  CipUdint ip_address; /**< IP being valid during NetworkHandlerInitialize() */
+  CipUdint network_mask; /**< network mask being valid during NetworkHandlerInitialize() */
   MilliSeconds elapsed_time;
 } NetworkStatus;
 
